// Copyright (c) 1997 Andrew Maltsev <am@amsoft.ru>
// All rights reserved
// 
// Yet another example.
//
// Very simple query tool. Usage:
//  query database query
//
// Where database is a database name, and query is an SQL query.
//
// Implemented via class, derived from easysql just to show that ability.
//
// $Id: query.C,v 1.1 1997/11/05 19:51:47 am Exp $
//
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "easysql.h"

///////////////////////////////////////////////////////////////////////////////
// Derived class declaration
//
class sql : easysql
{public:
  sql(char const *db);
  ~sql();
  bool query(char const *q);
};

///////////////////////////////////////////////////////////////////////////////
// Main
//
int
main(int ac, char *av[])
{ if(ac<3)
   { printf("-- EasySQL query tool. Copyright (c) 1997 by Andrew Maltsev\n\n"
            "Usage:\n"
            " query database sql-query\n"
            "Examples:\n"
            " query mydb 'SELECT * FROM users WHERE USER=\"super\"'\n"
            "\n"
            " query users 'UPDATE accounts SET category=12 WHERE id=1234'\n"
            "\n");
     exit(1);
   }

  char const *db=av[1];

  unsigned size=1;
  for(int i=2; i!=ac; i++)
   size+=strlen(av[i])+1;
  char *query=(typeof(query))malloc(sizeof(*query)*size);
  if(!query)
   { printf("Not enough memory to allocate %u chars!\n",size);
     exit(1);
   }
  strcpy(query,av[2]);
  for(int i=3; i!=ac; i++)
   strcat(strcat(query," "),av[i]);

// Sending query
//
  sql s(db);
  return s.query(query) ? 0 : 1;
}

///////////////////////////////////////////////////////////////////////////////
// Creating instance of our class
//
sql::sql(char const *db)
    :easysql(db)
{ set_retry_delay(0);
}

///////////////////////////////////////////////////////////////////////////////
// Destroing instance of our class
//
sql::~sql()
{
}

///////////////////////////////////////////////////////////////////////////////
// Sending query, fetching and printing results
//
bool
sql::query(char const *q)
{ esqlResult r=easysql::query("%s",q);
  if(error_text())
   { printf("Error: %s\n",error_text());
     return false;
   }
  esqlRow datarow=row(r);
  if(row)
   { unsigned long n=0;
     printf("There is no way to determine how many fields present in returned\n"
            "rows of data in that release of EasySQL. I'm planning to add some\n"
            "get_field_num/get_row_num/.. stuff into EasySQL later, and if you\n"
            "want it quckier - feel free to ask me, am@amsoft.ru\n\n"
            "For now only very first field content is printed for every\n"
            "returned row:\n");
     while(datarow)
      { printf("%5lu) %s, ...\n",++n,datarow[0] ? datarow[0] : "<NULL>");
        datarow=row(r);
      }
    }
   else
    printf("Query succeded, but produced no data\n");
   rfree(r);
   return true;
}
